/**
 * SC2.java
 *
 * File generated from the medication2::SC2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class SC2.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "SC", propOrder = {
	"code",
	"codeSystem",
	"codeSystemName",
	"codeSystemVersion",
	"displayName"
})
@XmlRootElement(name = "SC2")
public class SC2 extends net.ihe.gazelle.medication2.ST12 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                       The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                        .
	 */
	@XmlAttribute(name = "code")
	public String code;
	/**
	 *                       Specifies the code system that
	                            defines the code.                   .
	 */
	@XmlAttribute(name = "codeSystem")
	public java.lang.String codeSystem;
	/**
	 *                       A common name of the coding system.
	                        .
	 */
	@XmlAttribute(name = "codeSystemName")
	public java.lang.String codeSystemName;
	/**
	 *                       If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                        .
	 */
	@XmlAttribute(name = "codeSystemVersion")
	public java.lang.String codeSystemVersion;
	/**
	 *                       A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                   .
	 */
	@XmlAttribute(name = "displayName")
	public java.lang.String displayName;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return code.
	 * @return code :                       The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                        
	 */
	public String getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code :                       The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                        .
	 */
	public void setCode(String code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return codeSystem.
	 * @return codeSystem :                       Specifies the code system that
	                            defines the code.                   
	 */
	public java.lang.String getCodeSystem() {
	    return codeSystem;
	}
	
	/**
	 * Set a value to attribute codeSystem.
	 * @param codeSystem :                       Specifies the code system that
	                            defines the code.                   .
	 */
	public void setCodeSystem(java.lang.String codeSystem) {
	    this.codeSystem = codeSystem;
	}
	
	
	
	
	/**
	 * Return codeSystemName.
	 * @return codeSystemName :                       A common name of the coding system.
	                        
	 */
	public java.lang.String getCodeSystemName() {
	    return codeSystemName;
	}
	
	/**
	 * Set a value to attribute codeSystemName.
	 * @param codeSystemName :                       A common name of the coding system.
	                        .
	 */
	public void setCodeSystemName(java.lang.String codeSystemName) {
	    this.codeSystemName = codeSystemName;
	}
	
	
	
	
	/**
	 * Return codeSystemVersion.
	 * @return codeSystemVersion :                       If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                        
	 */
	public java.lang.String getCodeSystemVersion() {
	    return codeSystemVersion;
	}
	
	/**
	 * Set a value to attribute codeSystemVersion.
	 * @param codeSystemVersion :                       If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                        .
	 */
	public void setCodeSystemVersion(java.lang.String codeSystemVersion) {
	    this.codeSystemVersion = codeSystemVersion;
	}
	
	
	
	
	/**
	 * Return displayName.
	 * @return displayName :                       A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                   
	 */
	public java.lang.String getDisplayName() {
	    return displayName;
	}
	
	/**
	 * Set a value to attribute displayName.
	 * @param displayName :                       A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                   .
	 */
	public void setDisplayName(java.lang.String displayName) {
	    this.displayName = displayName;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "SC2").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(SC2 sC2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (sC2 != null){
   			net.ihe.gazelle.medication2.ST12.validateByModule(sC2, _location, cvm, diagnostic);
    	}
    }

}
